From cca2e616e092c88cd476ebb4521ad4e6bba8387b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 18 2020 20:49:56 +0000
Subject: [PATCH 1744/2232] Add c_str() member function for rust::String


---

diff --git a/include/cxx.h b/include/cxx.h
index f41dde7..fc63095 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -53,6 +53,8 @@ public:
   std::size_t size() const noexcept;
   std::size_t length() const noexcept;
 
+  const char *c_str() noexcept;
+
   using iterator = char *;
   iterator begin() noexcept;
   iterator end() noexcept;
diff --git a/src/cxx.cc b/src/cxx.cc
index 776663e..6863129 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -42,6 +42,7 @@ bool cxxbridge1$string$from(rust::String *self, const char *ptr,
 void cxxbridge1$string$drop(rust::String *self) noexcept;
 const char *cxxbridge1$string$ptr(const rust::String *self) noexcept;
 std::size_t cxxbridge1$string$len(const rust::String *self) noexcept;
+void cxxbridge1$string$reserve_total(rust::String *self, size_t cap) noexcept;
 
 // rust::Str
 bool cxxbridge1$str$valid(const char *ptr, std::size_t len) noexcept;
@@ -127,6 +128,14 @@ std::size_t String::length() const noexcept {
   return cxxbridge1$string$len(this);
 }
 
+const char *String::c_str() noexcept {
+  auto len = this->length();
+  cxxbridge1$string$reserve_total(this, len + 1);
+  auto ptr = this->data();
+  const_cast<char *>(ptr)[len] = '\0';
+  return ptr;
+}
+
 String::iterator String::begin() noexcept {
   return const_cast<char *>(this->data());
 }
diff --git a/src/symbols/rust_string.rs b/src/symbols/rust_string.rs
index 944aec4..91fd78a 100644
--- a/src/symbols/rust_string.rs
+++ b/src/symbols/rust_string.rs
@@ -45,3 +45,8 @@ unsafe extern "C" fn string_ptr(this: &String) -> *const u8 {
 unsafe extern "C" fn string_len(this: &String) -> usize {
     this.len()
 }
+
+#[export_name = "cxxbridge1$string$reserve_total"]
+unsafe extern "C" fn string_reserve_total(this: &mut String, cap: usize) {
+    this.reserve(cap);
+}

